# RUN: llvm-mc -show-encoding -triple=mips-unknown-unknown -mattr=dspr2 %s | FileCheck %s
#
# CHECK:   .text
  precrq.qb.ph    $16,$17,$18  # CHECK: precrq.qb.ph     $16, $17, $18 # encoding: [0x7e,0x32,0x83,0x11]
  precrq.ph.w     $17,$18,$19  # CHECK: precrq.ph.w      $17, $18, $19 # encoding: [0x7e,0x53,0x8d,0x11]
  precrq_rs.ph.w  $18,$19,$20  # CHECK: precrq_rs.ph.w   $18, $19, $20 # encoding: [0x7e,0x74,0x95,0x51]
  precrqu_s.qb.ph $19,$20,$21  # CHECK: precrqu_s.qb.ph  $19, $20, $21 # encoding: [0x7e,0x95,0x9b,0xd1]
  preceq.w.phl    $20,$21      # CHECK: preceq.w.phl     $20, $21      # encoding: [0x7c,0x15,0xa3,0x12]
  preceq.w.phr    $21,$22      # CHECK: preceq.w.phr     $21, $22      # encoding: [0x7c,0x16,0xab,0x52]
  precequ.ph.qbl  $22,$23      # CHECK: precequ.ph.qbl   $22, $23      # encoding: [0x7c,0x17,0xb1,0x12]
  precequ.ph.qbr  $23,$24      # CHECK: precequ.ph.qbr   $23, $24      # encoding: [0x7c,0x18,0xb9,0x52]
  precequ.ph.qbla $24,$25      # CHECK: precequ.ph.qbla  $24, $25      # encoding: [0x7c,0x19,0xc1,0x92]
  precequ.ph.qbra $25,$26      # CHECK: precequ.ph.qbra  $25, $26      # encoding: [0x7c,0x1a,0xc9,0xd2]
  preceu.ph.qbl   $26,$27      # CHECK: preceu.ph.qbl    $26, $27      # encoding: [0x7c,0x1b,0xd7,0x12]
  preceu.ph.qbr   $27,$28      # CHECK: preceu.ph.qbr    $27, $gp      # encoding: [0x7c,0x1c,0xdf,0x52]
  preceu.ph.qbla  $28,$29      # CHECK: preceu.ph.qbla   $gp, $sp      # encoding: [0x7c,0x1d,0xe7,0x92]
  preceu.ph.qbra  $29,$30      # CHECK: preceu.ph.qbra   $sp, $fp      # encoding: [0x7c,0x1e,0xef,0xd2]
  precr.qb.ph     $23,$24,$25  # CHECK: precr.qb.ph      $23, $24, $25 # encoding: [0x7f,0x19,0xbb,0x51]
  precr_sra.ph.w  $24,$25,0    # CHECK: precr_sra.ph.w   $24, $25, 0   # encoding: [0x7f,0x38,0x07,0x91]
  precr_sra.ph.w  $24,$25,31   # CHECK: precr_sra.ph.w   $24, $25, 31  # encoding: [0x7f,0x38,0xff,0x91]
  precr_sra_r.ph.w  $25,$26,0  # CHECK: precr_sra_r.ph.w $25, $26, 0   # encoding: [0x7f,0x59,0x07,0xd1]
  precr_sra_r.ph.w  $25,$26,31 # CHECK: precr_sra_r.ph.w $25, $26, 31  # encoding: [0x7f,0x59,0xff,0xd1]
  lbux $10, $s4($26)           # CHECK: lbux $10, $20($26)             # encoding: [0x7f,0x54,0x51,0x8a]
  lhx  $11, $s5($27)           # CHECK: lhx  $11, $21($27)             # encoding: [0x7f,0x75,0x59,0x0a]
  lwx  $12, $s6($28)           # CHECK: lwx  $12, $22($gp)             # encoding: [0x7f,0x96,0x60,0x0a]
  mult $ac3, $2, $3            # CHECK: mult $ac3, $2, $3              # encoding: [0x00,0x43,0x18,0x18]
  multu $ac2, $4, $5           # CHECK: multu $ac2, $4, $5             # encoding: [0x00,0x85,0x10,0x19]
  madd $ac1, $6, $7            # CHECK: madd $ac1, $6, $7              # encoding: [0x70,0xc7,0x08,0x00]
  maddu $ac0, $8, $9           # CHECK: maddu $ac0, $8, $9             # encoding: [0x71,0x09,0x00,0x01]
  msub $ac3, $10, $11          # CHECK: msub $ac3, $10, $11            # encoding: [0x71,0x4b,0x18,0x04]
  msubu $ac2, $12, $13         # CHECK: msubu $ac2, $12, $13           # encoding: [0x71,0x8d,0x10,0x05]
  mfhi $14, $ac1               # CHECK: mfhi $14, $ac1                 # encoding: [0x00,0x20,0x70,0x10]
  mflo $15, $ac0               # CHECK: mflo $15, $ac0                 # encoding: [0x00,0x00,0x78,0x12]
  mthi $16, $ac3               # CHECK: mthi $16, $ac3                 # encoding: [0x02,0x00,0x18,0x11]
  mtlo $17, $ac2               # CHECK: mtlo $17, $ac2                 # encoding: [0x02,0x20,0x10,0x13]
  mult $2, $3                  # CHECK: mult $2, $3                    # encoding: [0x00,0x43,0x00,0x18]
  multu $4, $5                 # CHECK: multu $4, $5                   # encoding: [0x00,0x85,0x00,0x19]
  madd $6, $7                  # CHECK: madd $6, $7                    # encoding: [0x70,0xc7,0x00,0x00]
  maddu $8, $9                 # CHECK: maddu $8, $9                   # encoding: [0x71,0x09,0x00,0x01]
  msub $10, $11                # CHECK: msub $10, $11                  # encoding: [0x71,0x4b,0x00,0x04]
  msubu $12, $13               # CHECK: msubu $12, $13                 # encoding: [0x71,0x8d,0x00,0x05]
  mfhi $14                     # CHECK: mfhi $14                       # encoding: [0x00,0x00,0x70,0x10]
  mflo $15                     # CHECK: mflo $15                       # encoding: [0x00,0x00,0x78,0x12]
  mthi $16                     # CHECK: mthi $16                       # encoding: [0x02,0x00,0x00,0x11]
  mtlo $17                     # CHECK: mtlo $17                       # encoding: [0x02,0x20,0x00,0x13]
  append $2, $3, 3             # CHECK: append $2, $3, 3               # encoding: [0x7c,0x62,0x18,0x31]
  balign $4, $5, 1             # CHECK: balign $4, $5, 1               # encoding: [0x7c,0xa4,0x0c,0x31]
  prepend $6, $7, 4            # CHECK: prepend $6, $7, 4              # encoding: [0x7c,0xe6,0x20,0x71]
